# -*- coding: utf-8 -*-
from RoadCentre import plugins

class __rpc_creator__:
    def __init__(self,rpc_name):
        from RoadCentre import plugins
        self.name = rpc_name
        self.plugin = getattr(plugins,'JsonRpcClientPlugin',None)
        if self.plugin is None:
            return
        rpc_resp = self.plugin.postCommand(rpc_name,'introspect')
        rpc_resp.connect('responseFinished(Response*)',self._introspect_finished)
        
    def _introspect_finished(self,resp):
        method_list = resp.answer().get('result',{}).get('methods')
        if method_list is None:
            return
        import sys
        class_name = self.name+'Class'
        import re
        pattern=re.compile('[ (,)]')
        sub_objects = {}
        root_methods = []
        for signature in method_list:
            sig_list=list(filter(None,pattern.split(signature)))
            if len(sig_list)<2:
                continue
            if len(sig_list)%2:
                if sig_list[0]!='void':
                    sig_list.insert(0,'void')
                else:
                    sig_list.append('arg')
            arg_count=int(len(sig_list[2:])/2)
            arg_list=''
            for i in range(0,arg_count):
                if i>0: arg_list+=','
                arg_list+=sig_list[3+i*2]
            method_name = sig_list[1]
            obj_method = method_name.split('.')
            if len(obj_method)>1:
                sub_obj_name = obj_method[0]
                sub_obj_code_string = sub_objects.get(sub_obj_name)
                if sub_obj_code_string is None:
                    sub_obj_code_string='\tclass '+sub_obj_name+'Class:\n\t\tdef __init__(self,obj): self._rpc=obj\n'
                sub_obj_code_string+=self._method_def(sig_list[0],obj_method,arg_list,2)
                sub_objects[sub_obj_name]=sub_obj_code_string
            elif method_name in ['subscribe','unsubscribe','unsubscribeAll']:
                continue
            else:
                root_methods.append(self._method_def(sig_list[0],method_name,arg_list,1))

        object_code_string='class '+class_name+':\n'
        for obj_code in sub_objects.values():
            object_code_string += obj_code + '\n'
        object_code_string += '\tdef __init__(self,obj):\n'
        object_code_string += '\t\tself._rpc=obj\n'
        for obj_name in sub_objects.keys():
            object_code_string += '\t\tself.%s = self.%sClass(obj)\n\t\tdelattr(%s,"%sClass")\n' % (obj_name,obj_name,class_name,obj_name)
        object_code_string += '\n'.join(root_methods)
#        print(object_code_string)
        try:
            compiled_code=compile(object_code_string,'<string>','exec')
        except SyntaxError:
            from gui import msgError 
            msgError(object_code_string)
            return
        exec(compiled_code,globals())
        cur_moudle=sys.modules[__name__]
        RpcClass=getattr(cur_moudle,class_name)
        setattr(cur_moudle,self.name,RpcClass(self.plugin))
#        print('del',cur_moudle,class_name)
        delattr(cur_moudle,class_name)

    def _method_def(self,ret_type,method_name,arg_list,level):
        prefix = '\t'*level
        obj_name = ''
        if type(method_name) == list:
            obj_name,method_name = method_name[:2]
            obj_name+='.'
        object_code_string=prefix+'def '+method_name+'(self,'
        object_code_string+=arg_list
        object_code_string+='):\n'
        object_code_string+=prefix+'\t"""'+method_name+'('+arg_list+')\n'
        object_code_string+=prefix+'\t"""\n'
        if len(arg_list)==0:
            object_code_string+=prefix+'\trpc_ans = self._rpc.sendCommand("%s","%s")\n'%(self.name,obj_name+method_name)
        else:
            object_code_string+=prefix+'\trpc_ans = self._rpc.sendCommand("%s","%s",(%s,))\n'%(self.name,obj_name+method_name,arg_list)
        if ret_type!='void':
            object_code_string+=prefix+'\tres = rpc_ans.get("result")\n'
            object_code_string+=prefix+'\tif res is None:\n'
            object_code_string+=prefix+'\t\tfrom gui import msgError\n'
            object_code_string+=prefix+'\t\tmsgError(rpc_ans)\n'
            object_code_string+=prefix+'\treturn res\n'
        return object_code_string
        

if hasattr(plugins,'JsonRpcClientPlugin'):
    def __rpcObjectConnected__(rpc_obj_name):
        from RoadCentre import plugins
        json_rpc_plugin = getattr(plugins,'JsonRpcClientPlugin',None)
        if json_rpc_plugin is None:
            return
        __rpc_creator__(rpc_obj_name)
    
    def __rpcObjectDisonnected__(rpc_obj_name):
        from RoadCentre import plugins
        import sys
        cur_module=sys.modules.get(__name__)
        if cur_module and hasattr(cur_module,rpc_obj_name):
            delattr(cur_module,rpc_obj_name)
    conn_obj_list = plugins.JsonRpcClientPlugin.connectedObjects()
    if len(conn_obj_list) > 0:
        for obj_name in conn_obj_list:
            __rpc_creator__(obj_name)
        del obj_name
    plugins.JsonRpcClientPlugin.connect('rpcObjectConnected(const QString &)',__rpcObjectConnected__)
    plugins.JsonRpcClientPlugin.connect('rpcObjectDisonnected(const QString &)',__rpcObjectDisonnected__)
    del plugins
    del conn_obj_list
